%
% anyremote configuration file for Xine management. (Server-mode Command Fusion iViewer)
% prerequisites: Iviewer client installed on Ipod touch/Iphone 2.x and Iviewer free winamp GUI
%

% STATUS stable
% XTEST no
% SOUND mixer
% ENV no

GuiAppName=Xine
GuiAppBinary=true
GuiAppRun=echo 'P=`ps -ef|grep xine|grep -v grep|grep -v anyremote|grep -v edit|grep -v xinetd`; if [ "x$P" == "x" ]; then echo NOK; else echo OK; fi' | bash -f -s
GuiAppIcon=xine.png
GuiAppType=Application
GuiAppProtocols=iViewer
GuiAppDesc=Xine is a free multimedia player. It plays back CDs, DVDs, and VCDs.

[Protocol]=iViewer

%a1 = volume
%a2 = needs a constent update to. its the seek bar

%s1 = artist
%s2 = track
%s5 = current playback in min:sec
%s6 = song length min:sec.

% play
d1(1)=Exec(xine-remote -c play);

% stop
d30(1)=Exec(xine-remote -c stop);

% pause
d31(1)=Exec(xine-remote -c pause);

% next
d5(1)=Exec(xine-remote -c "seek +10");\
	Macro(TITLE);

% prev
d6(1)=Exec(xine-remote -c "seek -10");\
	Macro(TITLE);

% toggle repeat
d12(1)=Exec(echo "Toggle repeat")

% toggle shuffle
d9(1)=Exec(echo "Toggle shuffle")

% volume contol
a1($$)=Make(var,default_mixer_value,by_value,$(Index));\
        Macro(DEFAULT_VOLUME_SET);\
	Macro(VOLUME);

% seek >> and <<
a2($$)=Make(var,seek,echo "$(Index)*100/65535"|bc);\
	Exec(echo "got $(Index)");\
        Exec(echo "set position to $(seek)%");\
	Macro(PLAYBACK);

% Feedback
PLAYBACK=Send(string,s5=);ExecAndSend(string,echo "01:00");Send(bytes,3);\
        Make(var,playback_persent,echo "65535*"`echo 50`"/100"|bc);\
        Send(string,a2=$(playback_persent));Send(bytes,3);

% get volume: 0 - 65535
VOLUME=Macro(DEFAULT_VOLUME_GET);\
        Send(string,a1=$(default_mixer_value));Send(bytes,3);

% Artist name
ARTIST=ExecAndSend(string,echo "Artist is ...");

% Track
TRACK =ExecAndSend(string,echo "Track is ...");

% Song length mm:ss
SONG_LEN=ExecAndSend(string,echo "00:00");

%
% The following is a common part. In general, it should not be changed.
%

TITLE=\
	Send(string,s1=);Macro(ARTIST);Send(bytes,3);\
	Send(string,s2=);Macro(TRACK);Send(bytes,3);\
	Send(string,s6=);Macro(SONG_LEN);Send(bytes,3);

d5(0)=Macro(TITLE);
d6(0)=Macro(TITLE);

% Init
i(1)=Macro(TITLE);

% Password p(PASSWORD)"
p($$)=Send(string,p=ok);Send(bytes,3);

% Heartbeat
DISC=Macro(STOP_TIMERS);Make(disconnect);

h(0)=Timer(DISC,reset);

% no needs to send "h=1\03" replay directly because this will be done 
% automatically - that controlled by $(IViewer) variable
% If $(IViewer) variable is not set it needs to use the following command:
% h(0)=Send(bytes,104,61,49,3);Timer(DISC,reset);

STOP_TIMERS=\
	Timer(PLAYBACK,cancel);\
	Timer(VOLUME,cancel);\
	Timer(TITLE,cancel);

(Init)=Include($(CfgDir)/Utils/aliases-iviewer.cfg);\
	Macro(SETUP_DEFAULT_MIXER);\
	Make(var,IViewer,by_value,true);\
	Exec(echo 'if [ -f $HOME/.xine/passwd ]; then true; else echo "ALL:ALLOW" > $HOME/.xine/passwd; fi'|bash -f -s);

% Event timers
(Connect)=\
	Exec(echo 'P=`ps -ef|grep xine|grep -v grep|grep -v anyremote|grep -v edit|grep -v xinetd`; if [ "x$P" == "x" ]; then xine -n; fi' | bash -f -s);
	Timer(PLAYBACK,3,0);\
	Timer(VOLUME,10,0);\
	Timer(TITLE,5,0);

%	Timer(DISC,10,1);\

(Disconnect)=Macro(STOP_TIMERS);

[End]

